<?php
/**
 * TightURL Local Configuration File
 * Make all changes here, *not* in the TightURL script file.
 * 
 * @package TightURL
 * @author Ron Guerin <ron@vnetworx.net>
 */

/**
 *  MySQL variables
 */
$dbhost = "localhost";
$dbuser = "dbuser";
$dbpass = "dbpass";
$dbname = "tighturl";
$dbtable = "tighturl";

/**
 * Site
 */
$sitenames = array("example.com","www.example.com");

/**
 * Operating modes
 */
$FOFMethod = FALSE; //FALSE=Use full URL path or mod_rewrite, TRUE=Use 404 Method to compress URLs
$antiabuse = TRUE;  //0=do not run network checks or other anti-abuse measures on submitted URIs, 1=run tests 
                    //Must be set to something other than true to deactivate
$netchecks = TRUE;  //0=do not run network checks, 1=run network tests as part of anti-abuse system
$mustexist = TRUE;  //0=do not check URLs to see if they exist, 1=check URLs if netchecks are on.
$BB2=TRUE;          //0=do not use Bad Behavior, 1=Protect your site with Bad Behavior

/**
 * URIBL variables
 */
$uribl = array("multi.surbl.org", "black.uribl.com");
$uriblurl = array("www.surbl.org", "www.uribl.com");

/** Text strings and style variables
 *
 */
$svcname = "URLSquisher";
$verbtext = "Squish";
$pasttext = "Squished";
$tagline = "Squish long URLs to make short ones";
$headcolor = "#006600";
$tablecolor = "#00CC99";
$copystart = date("Y");
$copyrightholder = "SquishURL Enterprises";
$complain = true;
$validschemes = "(http|https|ftp|sftp)";
$forbid = "\.(cmd|bat|exe|scr|pif|vbs|js|pif|msi|cdr)";

// Validate IP addresses

$validipv4pattern  = ":\/\/(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\."
 . "(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])"
 . "\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\.(\d{1,2}|1\d\d|2[0-4]\d|25[0-5])\/*";

// Reserved URLs
$ReservedURL = array("x", "rest", "xmlrpc", "soap", "xml", "atom", "rss", "blog",
                     "faq", "help", "about", "api", "code", "source", "docs",
                     "cvs", "arch", "url", "admin", "setup", "svn", "project", "abuse", "exploited");
?>
